#!/usr/bin/python

import time

def measure(f):
    def stringify(f, args, kwargs, time):
        pos_args = [ repr(arg) for arg in args ]
        kw_args = [ "{}={}".format(k, repr(v)) for k, v in kwargs.items() ]
        all_args = ", ".join(pos_args + kw_args)
        return "{}({}) took {} sec".format(f.__name__, all_args, time)

    def wrapper(*args, **kwargs):
        start = time.monotonic()
        ret = f(*args, **kwargs)
        finish = time.monotonic()
        print(stringify(f, args, kwargs, finish - start))
        return ret

    return wrapper

@measure
def foo(*args, **kwargs):
    time.sleep(5)

foo(1, "two", 3, foo="foo", bar="bar")
